/* $Id: constants.cpp,v 1.37 2005/08/05 06:49:06 uwe Exp $ */

#include  "constants.hpp"

/**********************************************************/

// string-IDs of the objects
// The order must be identical to the one of the corresponding
// enumeration constants in constants.hpp
const char* const ObjectIDString[NUMBER_OF_OBJECT_IDs+1] =
{
	// no string for ID NON_VALID_OBJECT, since it has ID -1
	//
	// avatars
	"AVATAR_WORM",
	// collidable objects
	"BALL",
	"GRENADE",
	"MINE",
	"MISSILE",
	"HOMING_MISSILE",
	"GUIDED_MISSILE",
	"HELICOPTER",
	"HOOK",
	"STATIC_GUN_I",
	// -> bonus objects (also collidable)
	"BONUS_HEALTH",
	"BONUS_SHIELD",
	"BONUS_INVISIBLE",
	"BONUS_FUEL",
	"BONUS_HOMING_VIRUS",
	// noncollidable objects
	"EXPLOSION_15",
	"EXPLOSION_40",
	"EXPLOSION_60",
	"EXPLOSION_80",
	"SMOKE_15",
	"SMOKE_30",
	"BLUEGLOW_25",
	"GOAL_50",
	"SHIELD_CORONA",
	"INVISIBLE_CORONA",
	"ROPE",
	"STATIC_GUN_I_CHASSIS",
	// terminating "NULL" instead of "NUMBER_OF_OBJECT_IDs",
	// do not remove this, it might be important for some
	// routines (e.g. of SettingDataBase), that expect the
	// string list being terminated with a NULL string.
	0x00
};

/**********************************************************/

// string-IDs of the weapons
// The order must be identical to the one of the corresponding
// enumeration constants in constants.hpp
const char* const WeaponIDString[NUMBER_OF_WEAPON_IDs+1] =
{
	"SHOTGUN",
	"UZI",
	"RUBBERGUN",
	"GRENADE",
	"MINE",
	"MISSILE",
	"HOMING_MISSILE",
	"GUIDED_MISSILE",
	"WEAPON_HELICOPTER",
	"ZAPPER",
	"HOOK",
	"WEAPON_HOOK_REL",
	"WEAPON_HOOK_CUT",
	// terminating "NULL"
	0x00
};

/**********************************************************/

const Uint32 TEAM_COLOR[MAX_NUMBER_OF_PLAYERS] = {
	0x00dd0000, 0x0000dd00, 0x006666ff, 0x00ffff00, 0x00ff00ff, 0x0000ffff,
	0x00990000, 0x00009900, 0x004444aa, 0x00aaaa00, 0x00aa00aa, 0x0000aaaa,
	0x00440000, 0x00004400, 0x00222255, 0x00555500, 0x00550055, 0x00005555,
	0x00ffffff, 0x00aaaaaa
};
