/* $Id: weapongrenade.hpp,v 1.11 2005/08/12 08:54:10 pohlt Exp $ */

#ifndef _WEAPONGRENADE_HPP_
#define _WEAPONGRENADE_HPP_

#include "weapon.hpp"
#include "grenade.hpp"
#include "audio.hpp"

class WeaponGrenade : public Weapon {
	public:
		WeaponGrenade(): m_type (Grenade::TIME_TRIGGERED | Grenade::SHRAPNELS)  {
			m_ID          = WEAPON_GRENADE;
			m_maximumAmmo =   2;
			m_reloadTime  =  40;
			m_chargeTime  = 100;
			rechargeNow();
			m_shotSample = Audio::getInstance()->loadSound( "sound/weapons/grenade/drop_pin.wav" );
			Grenade::m_explodeSample = Audio::getInstance()->loadSound( "sound/effects/explosion1.wav" );
			Grenade::m_bounceSample = Audio::getInstance()->loadSound( "sound/weapons/grenade/bounce.wav" );
			Grenade::m_damageSample = Audio::getInstance()->loadSound( "sound/effects/ricochet.wav" );
		}

		virtual bool reallyShoot( World* world, Avatar* avatar,
		                          const StationaryGun* gun = NULL ) const ;

		void setType( const Uint32 type ) { m_type = type; }

	protected:
		Uint32 m_type;
};

#endif // _WEAPONGRENADE_HPP_
